#ifndef IDESSINABLE_H
#define IDESSINABLE_H

#include "stdafx.h"

class IDessinable
{
protected:
   D3DXMATRIX m_MatriceMonde;
   D3DXVECTOR3 m_Position;
public:
   D3DXVECTOR3 GetPosition () const { return m_Position; }
   void SetPosition (const D3DXVECTOR3 &Position) { m_Position = Position; }
   void SetMatriceMonde (const D3DXMATRIX &m) { m_MatriceMonde = m; }
   const D3DXMATRIX & GetMatriceMonde () const { return m_MatriceMonde; }
   IDessinable (const D3DXVECTOR3 &Position)
      : m_Position (Position)
   {
      // Initialiser la matrice de transformation (dfaut: matrice identit)
      ::D3DXMatrixIdentity (&m_MatriceMonde);
   }
   virtual void Draw (IDirect3DDevice9 *pDevice)
   {
      // Matrice de transformation dans le monde
      pDevice->SetTransform (D3DTS_WORLD, &m_MatriceMonde);
      DrawNoTransform (pDevice);
   }
   virtual void DrawNoTransform (IDirect3DDevice9 *) = 0;
   virtual ~IDessinable () {}
};

#endif // !defined IDESSINABLE_H
