// MainFrm.cpp : implmentation de la classe CMainFrame
//

#include "stdafx.h"
#include "TroisDUn.h"
#include "Util.h"
#include "Roue.h"
#include "Sphere.h"

#include <algorithm>

#include "MainFrm.h"
#include ".\mainfrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

const DWORD IMAGESPARSECONDE = 20;
class Camera
{
   D3DXMATRIX m_MatriceVision;
   D3DXVECTOR3 m_Position,
               m_Direction,
               m_Haut;
public:
   void GlisserCameraDe (const D3DXVECTOR3 &Deplacement, IDirect3DDevice9 *pDevice)
   {
      m_Position += Deplacement;
      PositionnerCamera (pDevice);
   }
   void PositionnerCamera (IDirect3DDevice9 *pDevice)
   {
      // Dfinir la matrice de vision
      ::D3DXMatrixLookAtLH (&m_MatriceVision,
                            &m_Position,  // position
                            &m_Direction, // direction
                            &m_Haut);     // haut
      pDevice->SetTransform (D3DTS_VIEW, &m_MatriceVision);

      // Matrice de projection
      D3DXMATRIX MatriceProjection;

      const float CHAMP_VISION = D3DX_PI/4, // 45 degrs
                  RATIO_ASPECT = 1.0f,
                  PLAN_RAPPROCHE = 1.0f,
                  PLAN_ELOIGNE = 100.0f;
      ::D3DXMatrixPerspectiveFovLH (&MatriceProjection,
                                    CHAMP_VISION,
                                    RATIO_ASPECT,
                                    PLAN_RAPPROCHE,
                                    PLAN_ELOIGNE);
      pDevice->SetTransform (D3DTS_PROJECTION, &MatriceProjection);
   }
   Camera (IDirect3DDevice9 *pDevice)
      : m_Position  (0.0f, 7.5f, -10.0f),
        m_Direction (0.0f, 0.0f,   0.0f),
        m_Haut      (0.0f, 1.0f,   0.0f)
   {
      PositionnerCamera (pDevice);
   }
};


// CMainFrame

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	ON_WM_CREATE()
   ON_WM_DESTROY()
   ON_WM_KEYDOWN()
END_MESSAGE_MAP()


// construction ou destructionde CMainFrame

CMainFrame::CMainFrame()
   : m_TempsCourant (0L), m_TempsSuivant (0L), m_TempsVieux (0L),
     m_TempsEcart (0L), m_EchelleTemps (0.0), m_Rotation (0.0f),
     m_pD3D (0), m_pCamera (0)
{
   Create (0, "MT2--Roue--Base", WS_OVERLAPPEDWINDOW, rectDefault, 0, MAKEINTRESOURCE(IDR_MAINFRAME));
}

CMainFrame::~CMainFrame()
{
}

//
//  partir d'ici, la fentre existe
//
int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

   //
   // Rendre la fentre carre (minimum des dimensions par dfaut)
   //
   RECT r = { 0 };
   GetWindowRect (&r);
   const long LARGEUR = r.right- r.left;
   const long HAUTEUR = r.bottom - r.top;
   const long TAILLE = (LARGEUR < HAUTEUR? LARGEUR : HAUTEUR);
   r.right = TAILLE + r.left;
   r.bottom = TAILLE + r.top;
   MoveWindow (&r, TRUE);

   // Initialisation des lments de DX
   try
   {
      // Cration de l'Environnement DX
      InitDirect3D();

      // Cration et initialsiation de la scne
      if (!InitScene ()) return -1;

      // Initialisation de l'animation et prparation de la 1ire image
      if (!InitAnimation ()) return -1;
   }
   catch (HRESULT hr)
   {
      CString Msg;
      if (!hr)
         Msg = "chec de l'opration";
      else
         Msg.Format ("chec de l'opration, code %d", hr);
      MessageBox (Msg, "Erreur");
      return -1;
   }

   return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO : Changez ici la classe ou les styles Window en modifiant
	//  CREATESTRUCT cs

	return TRUE;
}


// diagnostics pour CMainFrame

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG


//
// Initialiser les paramtres de l'animation et prparer la 1ire image
//
bool CMainFrame::InitAnimation()
{
   // ::timeGetTime(): winmm.lib, nb ms depuis dmarrage de Windows,
   // prcis  5ms prs
   m_TempsSuivant = ::timeGetTime ();
   m_EchelleTemps = 0.001;
   m_TempsEcart = 1000/IMAGESPARSECONDE;
   m_TempsVieux = m_TempsSuivant;

   // Prparer la 1ire image
   RendreScene();
   return true;
}

//
// Prparer une image dans le backbuffer. En version optimise, cette
// mthode ne fait pas d'affichage
//

namespace
{
   class Afficher
   {
      IDirect3DDevice9 *m_pD3DDevice;
   public:
      Afficher(IDirect3DDevice9 *pDevice) : m_pD3DDevice(pDevice) {}
      ~Afficher () {}
      void operator () (IDessinable *p) { if (p) p->Draw (m_pD3DDevice); }
   };
}

bool CMainFrame::RendreScene()
{
   const D3DCOLOR COULEUR_FOND = D3DCOLOR_XRGB (0, 0, 255);

   // Effacer le viewport en bleu
   m_pD3DDevice->Clear (0, 0, // lis aux rectangles  effacer (ici, on efface tout)
                        D3DCLEAR_TARGET | D3DCLEAR_ZBUFFER, // quoi effacer. Ici, surface de destination et Z-Buffer
                        COULEUR_FOND, // couleur  appliquer
                        1.0f, 0L); // effets

   // Le rendu  proprement dit
   m_pD3DDevice->BeginScene ();
   std::for_each (m_ObjetsDessinables.begin(), m_ObjetsDessinables.end(), Afficher (m_pD3DDevice));
   m_pD3DDevice->EndScene ();
   return true;
}

//
// Mthode d'animation. Optimise pour les systmes les moins rapides
// (effectue le flip au dbut du signal, puis construit la prochaine
// image).
bool CMainFrame::Animation ()
{
   float TempsEcoule (0.0f);

   m_TempsCourant = ::timeGetTime ();

   // Temps pour une nouvelle image?
   if (m_TempsCourant > m_TempsSuivant)
   {
      // Affichage optimis
      m_pD3DDevice->Present (0, 0, 0, 0);

      TempsEcoule = 
         static_cast<float>((m_TempsCourant - m_TempsVieux) * m_EchelleTemps);

      // Prparer la prochaine image
      AnimeScene (TempsEcoule);

      // Rendre l'image sur la surface de travail
      RendreScene ();

      // Calcul du temps du prochai naffichage
      m_TempsVieux = m_TempsCourant;
      m_TempsSuivant = m_TempsCourant + m_TempsEcart;
   }
   return true;
}

//
// Initialisation de D3D
//
void CMainFrame::InitDirect3D()
{
   // 1. Cration de l'objet D3D
   Valider (m_pD3D = Direct3DCreate9 (D3D_SDK_VERSION));

   // 2. Obtenir le mode d'affichage courant
   D3DDISPLAYMODE d3ddm;
   Essayer (m_pD3D->GetAdapterDisplayMode (D3DADAPTER_DEFAULT, &d3ddm));

   // 3. Initialiser l'enregistrement utilis pour crer le dispositif D3DDevice
   // - la plupart des paramtres sont mis  zro
   // - le champ windowed est TRUE: nous voulons du 3D dans une fentre
   // - le champ SwapEffect est discard, ce uqi est le moyen le plus rapide
   //   d'changer le backbuffer avec l'cran
   // - le backbuffer demand rencontrera les caractristiques du mode d'affichage
   //   courant.
   D3DPRESENT_PARAMETERS d3dpp = { 0 }; 
   d3dpp.Windowed = TRUE;
   d3dpp.SwapEffect = D3DSWAPEFFECT_DISCARD;
   d3dpp.BackBufferFormat = d3ddm.Format;

   // Implantation d'un tampon de profondeur
   d3dpp.EnableAutoDepthStencil = TRUE;
   d3dpp.AutoDepthStencilFormat = D3DFMT_D16;

   // 4. Cration du dispositif D3ddevice
   // - nous utilisons la carte vido par dfaut, puisuqe la plupart des systmes
   //   n'en ont qu'une seule
   // - software vertex processing est utilis parce qu'il fonctionnera sur
   //   toutes les cartes. On obtient une meilleure performance avec hardware
   //   vertex processing sur les cartes qui le supportent.
   Essayer ( m_pD3D->CreateDevice ( D3DADAPTER_DEFAULT,
                                    D3DDEVTYPE_HAL,
                                    m_hWnd,
                                    D3DCREATE_SOFTWARE_VERTEXPROCESSING,
                                    &d3dpp,
                                    &m_pD3DDevice) );

   // Activation du traitement des surfaces caches
   m_pD3DDevice->SetRenderState (D3DRS_ZENABLE, TRUE);
}

bool CMainFrame::InitScene ()
{
   // Initialisation des objets 3D (cration / chargement)
   if (!InitObjets ()) return false;
   // Initialisation des clairages
   if (!InitEclairage ()) return false;
   // Initialisation des transformations
   if (!InitTransformations()) return false;

   return true;
}

bool CMainFrame::InitObjets ()
{
   const double RAYON_CERCLE_ANNEAUX = 10.0;
   const double RAYON_ANNEAU = 2.0;
   const double LARGEUR = 2.0;
   const int NB_SEGMENTS = 12;

   D3DMATERIAL9 Materiau = { 0 };
   Materiau.Ambient.r = 0.75f;
   Materiau.Ambient.g = 0.75f;
   Materiau.Ambient.b = 0.25f;
   Materiau.Ambient.a = 1.0f;
   // Initialiser le RGBA pour la rflexion diffuse
   Materiau.Diffuse.r = 0.5f;
   Materiau.Diffuse.g = 0.0f;
   Materiau.Diffuse.b = 0.5f;
   Materiau.Diffuse.a = 1.0f;
   // Initialiser la couleur et l'intensit de la spcularit (lustre)
   Materiau.Specular.r = 1.0f;
   Materiau.Specular.g = 1.0f;
   Materiau.Specular.b = 1.0f;
   Materiau.Specular.a = 1.0f;
   // Initialiser le RGBA pour la couleur missive
   Materiau.Emissive.r = 0.0f;
   Materiau.Emissive.g = 0.0f;
   Materiau.Emissive.b = 0.0f;
   Materiau.Emissive.a = 0.0f;

   ////////////////////////////////////////////////////////////////////33
   // -- Dbut des modifications  faire
   //
   //
   // Pour le moment, notre anneau n'est fait que d'une seule roue. On
   // veut que l'anneau soit fait de douze (12) roues espaces galement
   // entre elles (indice: vous aurez  rdiger une boucle ou un truc du
   // mme genre).
   //
   // crivez du code propre. Utilisez des constantes aux endroits qui
   // s'y prteront. Ne mlangez pas NB_SEGMENTS (valeur 12, qui indique
   // le nombre de segments qui font une roue) et le nombre d'anneaux,
   // puisqu'on peut vouloir leur donner des valeurs diffrentes.
   //
   // Vous ne devriez pas modifier de code hors de la prsente section,
   //  moins de vouloir ajouter des constantes, des foncteurs ou des
   // trucs similaires. Crer le bon nombre de roues et les placer de
   // la bonne manire devrait suffire.
   //
   Roue *pRoue = new Roue (D3DXVECTOR3 (0.0f, 0.0f, 0.0f),
                           m_pD3DDevice, LARGEUR, RAYON_ANNEAU, NB_SEGMENTS, Materiau);
   // Positionner la roue
   D3DXMATRIX matTranslation;
   ::D3DXMatrixTranslation (&matTranslation, 0.0f, 0.0f, static_cast<const float>(RAYON_CERCLE_ANNEAUX));
   pRoue->SetMatriceMonde (matTranslation);
   m_ObjetsDessinables.push_back (pRoue);
   //
   //
   // -- Fin des modifications  faire
   ////////////////////////////////////////////////////////////////////33
  
   Materiau.Ambient.r = 0.75f;
   Materiau.Ambient.g = 0.0f;
   Materiau.Ambient.b = 0.0f;
   Materiau.Ambient.a = 1.0f;
   m_ObjetsDessinables.push_back
      (new Sphere (D3DXVECTOR3 (0.0f, 0.0f, static_cast<const float>(RAYON_CERCLE_ANNEAUX)), Materiau, m_pD3DDevice));

   return true;
}

void InitLumiereBlanchePure (IDirect3DDevice9 *pDevice, D3DLIGHT9 *Lumiere)
{
   // Choix: lumire blanche pure
   pDevice->SetRenderState (D3DRS_AMBIENT, 0xffffffff); // ou ~0
}

void InitLumiereBlanchePoint (IDirect3DDevice9 *pDevice, D3DLIGHT9 *Lumiere)
{
   pDevice->SetRenderState (D3DRS_AMBIENT, 0xff111111);

   ::memset (Lumiere, 0, sizeof (D3DLIGHT9));

   // Lumire: blanche, type point
   Lumiere->Type = D3DLIGHT_POINT;
   Lumiere->Diffuse.r  = 1.0f;
   Lumiere->Diffuse.g  = 1.0f;
   Lumiere->Diffuse.b  = 1.0f;
   Lumiere->Ambient.r  = 1.0f;
   Lumiere->Ambient.g  = 1.0f;
   Lumiere->Ambient.b  = 1.0f;
   Lumiere->Specular.r = 1.0f;
   Lumiere->Specular.g = 1.0f;
   Lumiere->Specular.b = 1.0f;

   // Position de la lumire: un peu en haut et derrire l'observateur
   Lumiere->Position.x =   0.0f;
   Lumiere->Position.y =  20.0f;
   Lumiere->Position.z = -20.0f;

   // Pas d'attnuation
   Lumiere->Attenuation0 = 1.0f;
   Lumiere->Range = 1000.0f;

   // Activer la lumire!
   pDevice->SetLight (0, Lumiere);
   pDevice->LightEnable (0, TRUE);
}

void InitLumiereBlancheDirectionnelle (IDirect3DDevice9 *pDevice, D3DLIGHT9 *Lumiere)
{
   pDevice->SetRenderState (D3DRS_AMBIENT, 0xff111111);

   ::memset (Lumiere, 0, sizeof (D3DLIGHT9));

   // Lumire: blanche, type point
   Lumiere->Type = D3DLIGHT_DIRECTIONAL;
   Lumiere->Diffuse.r  = 1.0f;
   Lumiere->Diffuse.g  = 1.0f;
   Lumiere->Diffuse.b  = 1.0f;
   Lumiere->Ambient.r  = 1.0f;
   Lumiere->Ambient.g  = 1.0f;
   Lumiere->Ambient.b  = 1.0f;
   Lumiere->Specular.r = 1.0f;
   Lumiere->Specular.g = 1.0f;
   Lumiere->Specular.b = 1.0f;

   // Spcifier un vecteur de direction
   Lumiere->Direction.x =   0.0f;
   Lumiere->Direction.y =  -1.0f;
   Lumiere->Direction.z =   1.0f;

   // Activer la lumire!
   pDevice->SetLight (0, Lumiere);
   pDevice->LightEnable (0, TRUE);
}

void InitLumiereBlancheSpot (IDirect3DDevice9 *pDevice, D3DLIGHT9 *Lumiere)
{
   pDevice->SetRenderState (D3DRS_AMBIENT, 0xff111111);

   ::memset (Lumiere, 0, sizeof (D3DLIGHT9));

   // Lumire: blanche, type point
   Lumiere->Type = D3DLIGHT_SPOT;
   Lumiere->Diffuse.r  = 1.0f;
   Lumiere->Diffuse.g  = 1.0f;
   Lumiere->Diffuse.b  = 1.0f;
   Lumiere->Ambient.r  = 1.0f;
   Lumiere->Ambient.g  = 1.0f;
   Lumiere->Ambient.b  = 1.0f;
   Lumiere->Specular.r = 1.0f;
   Lumiere->Specular.g = 1.0f;
   Lumiere->Specular.b = 1.0f;

   // Spcifier un vecteur de direction
   Lumiere->Direction.x =   0.0f;
   Lumiere->Direction.y =  -1.0f;
   Lumiere->Direction.z =   1.0f;

   // Position de la lumire: un peu en haut et derrire l'observateur
   Lumiere->Position.x =   0.0f;
   Lumiere->Position.y =  20.0f;
   Lumiere->Position.z = -20.0f;

   // Pas d'attnuation
   Lumiere->Attenuation0 = 1.0f;
   Lumiere->Range = 1000.0f;

   // Caractristiques du spot
   Lumiere->Falloff =     1.0f;         // chute linaire
   Lumiere->Theta   =     3.14f / 6.0f; // Cne interne
   Lumiere->Phi     = 2 * 3.14f / 6.0f; // Cne externe

   // Activer la lumire!
   pDevice->SetLight (0, Lumiere);
   pDevice->LightEnable (0, TRUE);
}

bool CMainFrame::InitEclairage ()
{
//   InitLumiereBlanchePure (m_pD3DDevice, &m_Lumiere1);
   InitLumiereBlanchePoint (m_pD3DDevice, &m_Lumiere1);
//   InitLumiereBlancheDirectionnelle (m_pD3DDevice, &m_Lumiere1);
//   InitLumiereBlancheSpot (m_pD3DDevice, &m_Lumiere1);

   return true;
}



bool CMainFrame::InitTransformations ()
{
   m_pCamera = new Camera (m_pD3DDevice);

   return true;
}

//
// Animer la scne
//

namespace // dclarations locales
{
   class Tourner
   {
      const float m_Rotation;
   public:
      Tourner (const float Rotation)
         : m_Rotation (Rotation)
      {
      }
      ~Tourner () {}
      void operator() (IDessinable *p)
      {
         Sphere *pSphere = dynamic_cast<Sphere*>(p);
         if (pSphere)
         {
            D3DXMATRIX matTranslation;
            ::D3DXMatrixTranslation (&matTranslation, pSphere->GetPosition ().x, pSphere->GetPosition ().y, pSphere->GetPosition ().z);
            D3DXMATRIX matRotation;
            // Modifier la matrice de l'objet
            ::D3DXMatrixRotationY (&matRotation, m_Rotation);
            pSphere->SetMatriceMonde (matTranslation * matRotation);
         }
      }
   };
}

bool CMainFrame::AnimeScene (float TempsEcoule)
{
   m_Rotation += ( D3DX_PI * 2.0f / 3.0f * TempsEcoule );
   // On tourne la Sphre
   std::for_each (m_ObjetsDessinables.begin (), m_ObjetsDessinables.end (),
                  Tourner (m_Rotation));
   return true;
}

void CMainFrame::OnDestroy()
{
   Nettoyer ();
   CFrameWnd::OnDestroy();
}

//
// Nettoyage...
//

namespace // dclarations locales
{
   void Detruire (IDessinable *p) { delete p; }
}


void CMainFrame::Nettoyer ()
{
   std::for_each (m_ObjetsDessinables.begin (), m_ObjetsDessinables.end (),::Detruire);
   m_ObjetsDessinables.clear ();
   delete m_pCamera;
   // Relcher les interfaces graphiques
   Relacher (m_pD3DDevice);
   Relacher (m_pD3D);
}

void CMainFrame::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags)
{
   // TODO : ajoutez ici le code de votre gestionnaire de messages et/ou les paramtres par dfaut des appels
   switch (nChar)
   {
   case VK_UP:
      m_pCamera->GlisserCameraDe (D3DXVECTOR3 ( 1.0f, 0.0f, 0.0f), m_pD3DDevice);
      break;
   case VK_DOWN:
      m_pCamera->GlisserCameraDe (D3DXVECTOR3 (-1.0f, 0.0f, 0.0f), m_pD3DDevice);
      break;
   case VK_RIGHT:
      m_pCamera->GlisserCameraDe (D3DXVECTOR3 (0.0f, -1.0f, 0.0f), m_pD3DDevice);
      break;
   case VK_LEFT:
      m_pCamera->GlisserCameraDe (D3DXVECTOR3 (0.0f,  1.0f, 0.0f), m_pD3DDevice);
      break;
   case VK_HOME:
      m_pCamera->GlisserCameraDe (D3DXVECTOR3 (0.0f, 0.0f, -1.0f), m_pD3DDevice);
      break;
   case VK_END:
      m_pCamera->GlisserCameraDe (D3DXVECTOR3 (0.0f, 0.0f,  1.0f), m_pD3DDevice);
      break;
   }
   CFrameWnd::OnKeyDown(nChar, nRepCnt, nFlags);
}
