// MainFrm.h : interface de la classe CMainFrame
//


#pragma once

#include "IDessinable.h"
#include <vector>
class Camera;

class CMainFrame : public CFrameWnd
{
public:
	CMainFrame();
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual ~CMainFrame();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif
protected:
// membres incorpors de la barre de contrle
	CToolBar    m_wndToolBar;
// Fonctions gnres de la table des messages
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	DECLARE_MESSAGE_MAP()
private:
   // Initialiser les paramtres de l'animation et prparer la 1ire image
   bool InitAnimation();
   // Animer la scne
   bool AnimeScene (float TempsEcoule);
   // Nettoyage...
   void Nettoyer ();
   long m_TempsCourant;
   long m_TempsSuivant;
   long m_TempsVieux;
   DWORD m_TempsEcart;
   double m_EchelleTemps;
   float m_Rotation;
   IDirect3D9 *m_pD3D; // reprsente D3D et le matriel sous-jacent
   IDirect3DDevice9 *m_pD3DDevice; // reprsente le dispositif d'affichage
   Camera *m_pCamera;
   // Ce qui sera affich
   std::vector<IDessinable *> m_ObjetsDessinables;
   D3DLIGHT9 m_Lumiere1;
public:
   // Prparer une image dans le backbuffer. En version optimise, cette
   // mthode ne fait pas d'affichage
   bool RendreScene();
   // Mthode d'animation. Optimise pour les systmes les moins rapides
   // (effectue le flip au dbut du signal, puis construit la prochaine
   // image).
   bool Animation ();
   // Initialisation de D3D
   void InitDirect3D();
   // Initialisation de la scne
   bool InitScene();
   // Initialisation des objets 3D (cration / chargement)
   bool InitObjets();
   // Initialisation des clairages
   bool InitEclairage();
   // Initialisation des transformations
   bool InitTransformations();
   afx_msg void OnDestroy();
   afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
};


