#include "ObjetComplexe.h"
#include <algorithm>

namespace
{
   template <class T> void Detruire (T p) { delete p; }
   class Dessiner
   {
      IDirect3DDevice9 *m_pDevice;
   public:
      Dessiner (IDirect3DDevice9 *pDevice) : m_pDevice (pDevice) { }
      virtual ~Dessiner () {}
      void operator () (IDessinable *p) { p->DrawNoTransform (m_pDevice); }
   };
}

ObjetComplexe::~ObjetComplexe ()
{
   std::for_each (m_ObjetsConstitutifs.begin (), m_ObjetsConstitutifs.end (), ::Detruire<IDessinable*>);
}

void ObjetComplexe::Draw(IDirect3DDevice9 *pDevice)
{
   // Matrice de transformation dans le monde
   pDevice->SetTransform (D3DTS_WORLD, &m_MatriceMonde);
   DrawNoTransform (pDevice);
}

void ObjetComplexe::DrawNoTransform(IDirect3DDevice9 *pDevice)
{
   std::for_each (m_ObjetsConstitutifs.begin (), m_ObjetsConstitutifs.end (), ::Dessiner (pDevice));
}
