#ifndef SURFACE_RESTANGULAIRE_H
#define SURFACE_RESTANGULAIRE_H

#include "stdafx.h"
#include "Sommet.h"
#include "IDessinable.h"
#include "Util.h"
#include <vector>

class SurfaceRectangulaire : public IDessinable
{
   struct __MateriauDefaut
   {
      D3DMATERIAL9 m_Materiau;
      __MateriauDefaut ();
   };
   static __MateriauDefaut _MateriauDefaut;
   IDirect3DVertexBuffer9 *m_pVB; // vertex buffer du plan
   IDirect3DIndexBuffer9 *m_pIB; // index buffer du plan
   D3DMATERIAL9 m_Materiau; // matriau du plan
   void InitIndexBuffer (IDirect3DDevice9 *pDevice);
   enum
   {
      NB_SOMMETS = 4,
      NB_FACES = 2,
      NB_SOMMETS_DISTINCTS = NB_SOMMETS * NB_FACES,
      NB_PRIMITIVES_FACE = 2,
      NB_SOMMETS_PRIMITIVE = 3,
      NB_PRIMITIVES = NB_PRIMITIVES_FACE * NB_FACES
   };
   const float m_Hauteur,
               m_Largeur;
public:
   static const float
      HAUTEUR, LARGEUR;
   SurfaceRectangulaire(const D3DXVECTOR3 &_origine,
                        IDirect3DDevice9 *pDevice,
                        const float Largeur = LARGEUR,
                        const float Hauteur = HAUTEUR,
                        const D3DMATERIAL9 &Materiau = MateriauDefaut (),
                        const std::vector<D3DXVECTOR3> &_Normales = std::vector<D3DXVECTOR3>());
   static const D3DMATERIAL9 &MateriauDefaut () { return _MateriauDefaut.m_Materiau; }
   virtual ~SurfaceRectangulaire();
   virtual void DrawNoTransform(IDirect3DDevice9 *pDevice);
};

#endif // !defined SURFACE_RESTANGULAIRE_H
